dmatusz3

Szablony i skrypty startowe ZWPack

Recommended Posts

5 godzin temu, Adam Klaczek napisał:

Dzień dobry,

Czy _DVIEW - opcja S - kąt nie da pożądanego efektu?

nie używam, bo działa to dla mnie nazbyt skomplikowanie ;-).
Opcji obrotu o kąt nie widzę, a chodziło mi konkretnie o obrót widoku metodą punkt-punkt, bez zmiany zoomu..

image.png.53e31b93a4f86f58d11e4b5cdf7f7702.png

Share this post


Link to post
Share on other sites

Ło matko (i córko!), dziękuję, działa cudownie!! 😍😍

PS. Czy można dołożyć do tej komendy powrót do obrotu "0", np. za pomocą cyferki 0, w momencie jak pada zapytanie i pierwszy punkt? Było by mniej klikania 😉 

Edited by alf

Share this post


Link to post
Share on other sites

Moja propozycja implementacji powyższej funkcjonalności bez obracania gridem.

(defun RTD (/ANG) (/ (* ANG 180.0) pi))

(defun C:DWS2 (/ P1 P2 ANG)
  (if (setq P2 (getpoint "\--- Wskaż lewy punkt: " )			
; _ end of GETPOINT
      ) ;_ end of SETQ
    (progn (initget 1)
	   (setq P1  (getpoint "\n--- Wskaż prawy punkt: " P2)
		 ANG (angle P2 P1)
	   ) ;_ end of SETQ
	   (command "_UCS" "Z" P2 P1)		; zwykly obróy względem osiZ
	   (command "_plan" "C")		; widok na aktualny UCS
    ) ;_  end of PROGN
  ) ;_  end of IF
  (princ)
) ;_  end of DEFUN

(defun C:00 ()
  (command "_-view" "top")			; jest na to ikonka na pasku View więc komenda mało potrzebna ale niech tam...
) ;_  end of DEFUN

 

Share this post


Link to post
Share on other sites

Twój wariant @perlon jest uniwersalny i działa też na starszym ZWCAD np. 2015+ ale ma niestety taki minus, że po zmianie UCS rysunek robi _zoom _extens, co przy większych rysunkach bywa drażniące :) Zrobiłem własną przeróbkę Twojej wersji. UCS ustawia się w punkcie bazowym przy lewym punkcie (P2) i na koniec wykonywany jest zoom na ten punkt z bieżącym zbliżeniem.

;;; Obrot UCS i PLAN wzgledem nowego punktu bazowego (P2)
(defun C:UCS2 (/ P1 P2 Z)
  (if (setq P2 (getpoint "\--- Wskaż lewy punkt: " )			
; _ end of GETPOINT
      ) ;_ end of SETQ
    (progn (initget 1)
	   (setq P1  (getpoint "\n--- Wskaż prawy punkt: " P2)
		 Z (getvar "VIEWSIZE")
	   ) ;_ end of SETQ
	   (command "_ucs" P2 P1 "")	; zwykly obrot wzgledem nowego punktu bazowego (P2)
	   (command "_plan" "C")		; widok na aktualny UCS
	   (command "_zoom" "_c" "0,0" Z)
    ) ;_  end of PROGN
  ) ;_  end of IF
  (princ)
) ;_  end of DEFUN

 

Share this post


Link to post
Share on other sites

uwaga formalna:

powyższy skrypt powoduje przesunięcie punktu 0,0,0 w inne miejsce stąd obrót dws2 powoduje zmianę w układzie współrzędnych a pierwotny skrypt miał za zadanie nie robic obrotu układu wsp tylko obrót samego widoku.. kłopotliwe w skrypcie DWS jest to, że po obrocie zw odmierza kont nie od poziomu widoku (obróconego) ale nadal od osi "X" układu "word" ale za to działa orto jak należy..

image.png.2aab92ea8cc761f3675fbc6c3e49feea.png

 

image.png.53ad33f294f8f6e49ed6c3b1c3163eea.png

image.png.430b8387a12c49f6cc42e45895f187cc.png

Share this post


Link to post
Share on other sites

Tak, zgadzam się - DWS nie zmienia układu współrzędnych, zaś DWS2 i UCS2 zmieniają.

Komenda _DVIEW nie jest dostępna w starszych wersjach ZWCAD (np. w 2015+) i tam obrót jest widoku jest możliwy tylko przy pomocy zmiany układu współrzędnych. Innej metody ja przynajmniej nie znam.

Share this post


Link to post
Share on other sites

Dodaliśmy do zwpack 4 nowe funkcje:

Więcej o nakładce.

 

zmiana_stylu_multilinii.gif

suma dlugosci linii

 

 

Share this post


Link to post
Share on other sites

Join the conversation

You can post now and register later. If you have an account, sign in now to post with your account.

Guest
Reply to this topic...

×   Pasted as rich text.   Paste as plain text instead

  Only 75 emoji are allowed.

×   Your link has been automatically embedded.   Display as a link instead

×   Your previous content has been restored.   Clear editor

×   You cannot paste images directly. Upload or insert images from URL.

Loading...